#$Id$

package Data::Squirrel::GDBM_File;

use strict;
use vars qw(@ISA);

@ISA = qw(Data::Squirrel);

use Data::Squirrel;
use Apache::Session::Lock::File;
use Data::Squirrel::Store::GDBM_File;
use Apache::Session::Generate::MD5;
use Apache::Session::Serialize::Storable;

sub populate 
{
    my $self = shift;

    $self->{object_store} = new Data::Squirrel::Store::GDBM_File $self;
    $self->{lock_manager} = new Apache::Session::Lock::File $self;
    $self->{generate}     = \&Apache::Session::Generate::MD5::generate;
    $self->{validate}     = \&Apache::Session::Generate::MD5::validate;
    $self->{serialize}    = \&Apache::Session::Serialize::Storable::serialize;
    $self->{unserialize}  = \&Apache::Session::Serialize::Storable::unserialize;

    return $self;
}

sub list_ids 
{
    my($self)=@_;
    return $self->{object_store}->list_ids($self);
}


1;

__END__
$Log$