# $Id$

package Data::Squirrel::MySQL;

use strict;
use vars qw(@ISA $VERSION);

$VERSION = '1.01';
@ISA = qw(Data::Squirrel);

use Data::Squirrel;
use Apache::Session::Lock::MySQL;
use Data::Squirrel::Store::MySQL;
use Apache::Session::Generate::MD5;
use Apache::Session::Serialize::Storable;

sub populate 
{
    my $self = shift;

    $self->{object_store} = new Data::Squirrel::Store::MySQL $self;
    $self->{lock_manager} = new Apache::Session::Lock::MySQL $self;
    $self->{generate}     = \&Apache::Session::Generate::MD5::generate;
    $self->{validate}     = \&Apache::Session::Generate::MD5::validate;
    $self->{serialize}    = \&Apache::Session::Serialize::Storable::serialize;
    $self->{unserialize}  = \&Apache::Session::Serialize::Storable::unserialize;

    return $self;
}

sub list_ids 
{
    my($self)=@_;
    return $self->{object_store}->list_ids($self);
}

1;
